Index: /branches/SHM-dev/source/App/TAppDecoder/TAppDecCfg.cpp
===================================================================
--- /branches/SHM-dev/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 1441)
+++ /branches/SHM-dev/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 1442)
@@ -63,10 +63,8 @@
     \param argv array of arguments
  */
-Bool TAppDecCfg::parseCfg( Int argc, Char* argv[] )
+Bool TAppDecCfg::parseCfg( Int argc, TChar* argv[] )
 {
   Bool do_help = false;
-  string cfg_BitstreamFile;
-#if SVC_EXTENSION
-  string cfg_ReconFile [MAX_LAYERS];
+#if SVC_EXTENSION  
   Int layerNum, targetLayerId;
   Int olsIdx;
@@ -74,9 +72,4 @@
   string cfg_confPrefix;
 #endif
-#if AVC_BASE
-  string cfg_BLReconFile;
-#endif
-#else
-  string cfg_ReconFile;
 #endif
 
@@ -90,10 +83,10 @@
 
   ("help",                      do_help,                               false,      "this help text")
-  ("BitstreamFile,b",           cfg_BitstreamFile,                     string(""), "bitstream input file name")
-#if SVC_EXTENSION
-  ("ReconFileL%d,-o%d",                   cfg_ReconFile,   string(""), MAX_LAYERS, "Layer %d reconstructed YUV output file name\n"
+  ("BitstreamFile,b",           m_bitstreamFileName,                   string(""), "bitstream input file name")
+#if SVC_EXTENSION
+  ("ReconFileL%d,-o%d",                 m_reconFileName,   string(""), MAX_LAYERS, "Layer %d reconstructed YUV output file name\n"
                                                                                    "YUV writing is skipped if omitted")
 #if AVC_BASE
-  ("BLReconFile,-ibl",                               cfg_BLReconFile,  string(""), "BL reconstructed YUV input file name")
+  ("BLReconFile,-ibl",                              m_reconFileNameBL, string(""), "BL reconstructed YUV input file name")
 #endif
   ("TargetLayerId,-lid",                                        targetLayerId, -1, "Target layer id")
@@ -105,5 +98,5 @@
 #endif
 #else
-  ("ReconFile,o",               cfg_ReconFile,                         string(""), "reconstructed YUV output file name\n"
+  ("ReconFile,o",               m_reconFileName,                       string(""), "reconstructed YUV output file name\n"
                                                                                    "YUV writing is skipped if omitted")
 #endif
@@ -134,7 +127,7 @@
   po::setDefaults(opts);
   po::ErrorReporter err;
-  const list<const Char*>& argv_unhandled = po::scanArgv(opts, argc, (const Char**) argv, err);
-
-  for (list<const Char*>::const_iterator it = argv_unhandled.begin(); it != argv_unhandled.end(); it++)
+  const list<const TChar*>& argv_unhandled = po::scanArgv(opts, argc, (const TChar**) argv, err);
+
+  for (list<const TChar*>::const_iterator it = argv_unhandled.begin(); it != argv_unhandled.end(); it++)
   {
     fprintf(stderr, "Unhandled argument ignored: `%s'\n", *it);
@@ -163,6 +156,4 @@
   }
 
-  /* convert std::string to c string for compatability */
-  m_pchBitstreamFile = cfg_BitstreamFile.empty() ? NULL : strdup(cfg_BitstreamFile.c_str());
 #if SVC_EXTENSION
   if( targetLayerId < 0 )
@@ -204,23 +195,7 @@
   m_commonDecoderParams.setTargetOutputLayerSetIdx( olsIdx );
   m_commonDecoderParams.setTargetLayerId( targetLayerId );
-
-#if CONFORMANCE_BITSTREAM_MODE
-  for(Int layer = 0; layer < MAX_VPS_LAYER_IDX_PLUS1; layer++ )
-  {
-#else
-  for(UInt layer=0; layer<= m_tgtLayerId; layer++)
-  {
-    assert( layer < MAX_LAYERS );
-#endif
-    m_pchReconFile[layer] = cfg_ReconFile[layer].empty() ? NULL : strdup(cfg_ReconFile[layer].c_str());
-  }
-#if AVC_BASE
-  m_pchBLReconFile = cfg_BLReconFile.empty() ? NULL : strdup(cfg_BLReconFile.c_str());
-#endif
-#else
-  m_pchReconFile = cfg_ReconFile.empty() ? NULL : strdup(cfg_ReconFile.c_str());
-#endif
-
-  if (!m_pchBitstreamFile)
+#endif
+
+  if (m_bitstreamFileName.empty())
   {
     fprintf(stderr, "No input file specified, aborting\n");
Index: /branches/SHM-dev/source/App/TAppDecoder/TAppDecCfg.h
===================================================================
--- /branches/SHM-dev/source/App/TAppDecoder/TAppDecCfg.h	(revision 1441)
+++ /branches/SHM-dev/source/App/TAppDecoder/TAppDecCfg.h	(revision 1442)
@@ -57,9 +57,9 @@
 {
 protected:
-  Char*         m_pchBitstreamFile;                     ///< input bitstream file name
+  std::string   m_bitstreamFileName;                    ///< input bitstream file name
 #if SVC_EXTENSION
-  Char*         m_pchReconFile [MAX_LAYERS];          ///< output reconstruction file name
+  std::string   m_reconFileName[MAX_LAYERS];            ///< output reconstruction file name
 #else
-  Char*         m_pchReconFile;                         ///< output reconstruction file name
+  std::string   m_reconFileName;                        ///< output reconstruction file name
 #endif
   Int           m_iSkipFrame;                           ///< counter for frames prior to the random access point to skip
@@ -84,5 +84,5 @@
 #if SVC_EXTENSION
 #if AVC_BASE
-  Char*         m_pchBLReconFile;                     ///< input BL reconstruction file name
+  std::string   m_reconFileNameBL;                     ///< input BL reconstruction file name
 #endif
   CommonDecoderParams             m_commonDecoderParams;
@@ -99,13 +99,15 @@
 public:
   TAppDecCfg()
-  : m_pchBitstreamFile(NULL)
+  : m_bitstreamFileName()
 #if !SVC_EXTENSION
-  , m_pchReconFile(NULL)
+  , m_reconFileName()
 #endif
   , m_iSkipFrame(0)
+  // m_outputBitDepth array initialised below
   , m_outputColourSpaceConvert(IPCOLOURSPACE_UNCHANGED)
   , m_iMaxTemporalLayer(-1)
   , m_decodedPictureHashSEIEnabled(0)
   , m_decodedNoDisplaySEIEnabled(false)
+  , m_targetDecLayerIdSet()
 #if Q0074_COLOUR_REMAPPING_SEI
   , m_colourRemapSEIEnabled(0)
@@ -115,4 +117,6 @@
   , m_forceDecodeBitDepth(0)
 #endif
+  , m_outputDecodedSEIMessagesFilename()
+  , m_bClipOutputVideoToRec709Range(false)
   {
     for (UInt channelTypeIndex = 0; channelTypeIndex < MAX_NUM_CHANNEL_TYPE; channelTypeIndex++)
@@ -124,5 +128,5 @@
   virtual ~TAppDecCfg() {}
 
-  Bool  parseCfg        ( Int argc, Char* argv[] );   ///< initialize option class from configuration
+  Bool  parseCfg        ( Int argc, TChar* argv[] );   ///< initialize option class from configuration
 
 #if SVC_EXTENSION
Index: /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1441)
+++ /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1442)
@@ -90,9 +90,5 @@
 Void TAppDecTop::destroy()
 {
-  if (m_pchBitstreamFile)
-  {
-    free (m_pchBitstreamFile);
-    m_pchBitstreamFile = NULL;
-  }
+  m_bitstreamFileName.clear();
 #if SVC_EXTENSION
 #if CONFORMANCE_BITSTREAM_MODE
@@ -102,9 +98,5 @@
 #endif
   {
-    if( m_pchReconFile[i] )
-    {
-      free ( m_pchReconFile[i] );
-      m_pchReconFile[i] = NULL;
-    }
+    m_reconFileName[i].clear();
 
     if( m_apcTDecTop[i] )
@@ -121,16 +113,8 @@
   }
 #if AVC_BASE
-  if( m_pchBLReconFile )
-  {
-    free ( m_pchBLReconFile );
-    m_pchBLReconFile = NULL;
-  }
-#endif
-#else
-  if (m_pchReconFile)
-  {
-    free (m_pchReconFile);
-    m_pchReconFile = NULL;
-  }
+  m_reconFileNameBL.clear();
+#endif
+#else
+  m_reconFileName.clear();
 #endif
 #if Q0074_COLOUR_REMAPPING_SEI
@@ -160,8 +144,8 @@
   TComList<TComPic*>* pcListPic = NULL;
 
-  ifstream bitstreamFile(m_pchBitstreamFile, ifstream::in | ifstream::binary);
+  ifstream bitstreamFile(m_bitstreamFileName.c_str(), ifstream::in | ifstream::binary);
   if (!bitstreamFile)
   {
-    fprintf(stderr, "\nfailed to open bitstream file `%s' for reading\n", m_pchBitstreamFile);
+    fprintf(stderr, "\nfailed to open bitstream file `%s' for reading\n", m_bitstreamFileName.c_str());
     exit(EXIT_FAILURE);
   }
@@ -203,7 +187,7 @@
   TComPic pcBLPic;
   fstream streamYUV;
-  if( m_pchBLReconFile )
-  {
-    streamYUV.open( m_pchBLReconFile, fstream::in | fstream::binary );
+  if( !m_reconFileNameBL.empty() )
+  {
+    streamYUV.open( m_reconFileNameBL, fstream::in | fstream::binary );
   }
   TComList<TComPic*> *cListPic = m_apcTDecTop[0]->getListPic();
@@ -329,5 +313,5 @@
     if( pcListPic )
     {
-      if ( m_pchReconFile[curLayerId] && !openedReconFile[curLayerId] )
+      if ( !m_reconFileName[curLayerId].empty() && !openedReconFile[curLayerId] )
       {
         const BitDepths &bitDepths=pcListPic->front()->getSlice(0)->getBitDepths(); // use bit depths of first reconstructed picture.
@@ -339,5 +323,5 @@
           }
         }
-        m_apcTVideoIOYuvReconFile[curLayerId]->open( m_pchReconFile[curLayerId], true, m_outputBitDepth, m_outputBitDepth, bitDepths.recon ); // write mode
+        m_apcTVideoIOYuvReconFile[curLayerId]->open( m_reconFileName[curLayerId], true, m_outputBitDepth, m_outputBitDepth, bitDepths.recon ); // write mode
 
         openedReconFile[curLayerId] = true;
@@ -442,8 +426,8 @@
   TComList<TComPic*>* pcListPic = NULL;
 
-  ifstream bitstreamFile(m_pchBitstreamFile, ifstream::in | ifstream::binary);
+  ifstream bitstreamFile(m_bitstreamFileName.c_str(), ifstream::in | ifstream::binary);
   if (!bitstreamFile)
   {
-    fprintf(stderr, "\nfailed to open bitstream file `%s' for reading\n", m_pchBitstreamFile);
+    fprintf(stderr, "\nfailed to open bitstream file `%s' for reading\n", m_bitstreamFileName.c_str());
     exit(EXIT_FAILURE);
   }
@@ -548,5 +532,5 @@
     if( pcListPic )
     {
-      if ( m_pchReconFile && !openedReconFile )
+      if ( (!m_reconFileName.empty()) && (!openedReconFile) )
       {
         const BitDepths &bitDepths=pcListPic->front()->getPicSym()->getSPS().getBitDepths(); // use bit depths of first reconstructed picture.
@@ -559,5 +543,5 @@
         }
 
-        m_cTVideoIOYuvReconFile.open( m_pchReconFile, true, m_outputBitDepth, m_outputBitDepth, bitDepths.recon ); // write mode
+        m_cTVideoIOYuvReconFile.open( m_reconFileName, true, m_outputBitDepth, m_outputBitDepth, bitDepths.recon ); // write mode
         openedReconFile = true;
       }
@@ -648,5 +632,5 @@
 #endif
   {
-    if ( m_pchReconFile[layer] )
+    if ( !m_reconFileName[layer].empty() )
     {
       m_apcTVideoIOYuvReconFile[layer]->close();
@@ -657,7 +641,7 @@
   }
 #else
-  if ( m_pchReconFile )
-  {
-    m_cTVideoIOYuvReconFile. close();
+  if ( !m_reconFileName.empty() )
+  {
+    m_cTVideoIOYuvReconFile.close();
   }
 
@@ -792,5 +776,5 @@
         numPicsNotYetDisplayed = numPicsNotYetDisplayed-2;
 #if SVC_EXTENSION
-        if ( m_pchReconFile[layerId] )
+        if ( !m_reconFileName[layerId].empty() )
         {
           const Window &conf = pcPicTop->getConformanceWindow();
@@ -826,5 +810,5 @@
         m_aiPOCLastDisplay[layerId] = pcPicBottom->getPOC();
 #else
-        if ( m_pchReconFile )
+        if ( !m_reconFileName.empty() )
         {
           const Window &conf = pcPicTop->getConformanceWindow();
@@ -901,5 +885,5 @@
         }
 #if SVC_EXTENSION
-        if( m_pchReconFile[layerId] )
+        if ( !m_reconFileName[layerId].empty() )
         {
           const Window &conf = pcPic->getConformanceWindow();
@@ -920,5 +904,5 @@
         m_aiPOCLastDisplay[layerId] = pcPic->getPOC();
 #else
-        if ( m_pchReconFile )
+        if ( !m_reconFileName.empty() )
         {
           const Window &conf    = pcPic->getConformanceWindow();
@@ -1024,5 +1008,5 @@
         // write to file
 #if SVC_EXTENSION
-        if ( m_pchReconFile[layerId] )
+        if ( !m_reconFileName[layerId].empty() )
         {
           const Window &conf = pcPicTop->getConformanceWindow();
@@ -1043,5 +1027,5 @@
         m_aiPOCLastDisplay[layerId] = pcPicBottom->getPOC();
 #else
-        if ( m_pchReconFile )
+        if ( !m_reconFileName.empty() )
         {
           const Window &conf = pcPicTop->getConformanceWindow();
@@ -1103,5 +1087,5 @@
         // write to file
 #if SVC_EXTENSION
-        if ( m_pchReconFile[layerId] )
+        if ( !m_reconFileName[layerId].empty() )
         {
           const Window &conf = pcPic->getConformanceWindow();
@@ -1123,5 +1107,5 @@
         m_aiPOCLastDisplay[layerId] = pcPic->getPOC();
 #else
-        if ( m_pchReconFile )
+        if ( !m_reconFileName.empty() )
         {
           const Window &conf    = pcPic->getConformanceWindow();
@@ -1234,7 +1218,7 @@
 #if ALIGNED_BUMPING
 // Function outputs a picture, and marks it as not needed for output.
-Void TAppDecTop::xOutputAndMarkPic( TComPic *pic, const Char *reconFile, const Int layerId, Int &pocLastDisplay, DpbStatus &dpbStatus )
-{
-  if ( reconFile )
+Void TAppDecTop::xOutputAndMarkPic( TComPic *pic, std::string& reconFileName, const Int layerId, Int &pocLastDisplay, DpbStatus &dpbStatus )
+{
+  if( !reconFileName.empty() )
   {
     const Window &conf = pic->getConformanceWindow();
@@ -1488,5 +1472,5 @@
       TComPic *pic = *iterPic;
 
-      xOutputAndMarkPic( pic, m_pchReconFile[layerId], layerId, m_aiPOCLastDisplay[layerId], dpbStatus );
+      xOutputAndMarkPic( pic, m_reconFileName[layerId], layerId, m_aiPOCLastDisplay[layerId], dpbStatus );
 
 #if CONFORMANCE_BITSTREAM_MODE
@@ -1961,5 +1945,5 @@
 
     //Write remapped picture in decoding order
-    Char  cTemp[255];
+    TChar  cTemp[255];
     sprintf(cTemp, "seiColourRemappedPic_L%d_%dx%d_%dbits.yuv", layerId, iWidth, iHeight, storeCriSEI[layerId].m_colourRemapBitDepth );
     picColourRemapped.dump( cTemp, true, storeCriSEI[layerId].m_colourRemapBitDepth );
@@ -1974,5 +1958,5 @@
     if (storeCriSEI[layerId].m_colourRemapBitDepth == 8 || storeCriSEI[layerId].m_colourRemapBitDepth == 10)
     {
-      Char  cTemp[255];
+      TChar  cTemp[255];
       sprintf(cTemp, "seiColourRemappedPic_L%d_%dx%d_%dbits.yuv", layerId, pic.getWidth(COMPONENT_Y), pic.getHeight(COMPONENT_Y), storeCriSEI[layerId].m_colourRemapBitDepth );
       pic.dump( cTemp, true, storeCriSEI[layerId].m_colourRemapBitDepth );
Index: /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.h
===================================================================
--- /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.h	(revision 1441)
+++ /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.h	(revision 1442)
@@ -136,5 +136,5 @@
   Void flushAllPictures(Int layerId, Bool outputPictures);
 
-  Void xOutputAndMarkPic( TComPic *pic, const Char *reconFile, const Int layerId, Int &pocLastDisplay, DpbStatus &dpbStatus);
+  Void xOutputAndMarkPic( TComPic *pic, std::string& reconFileName, const Int layerId, Int &pocLastDisplay, DpbStatus &dpbStatus);
   Void outputAllPictures(Int layerId, Bool notOutputCurrAu);
   Void xFindDPBStatus( std::vector<Int> &listOfPocs
